from django.shortcuts import render
from django.http import HttpResponse

import calendar
from calendar import HTMLCalendar

from datetime import datetime

from .models import Event

def test_filt(request):

    test_value = "hello world"

    context = {
        "test_value": test_value,
    }

    return render(
        request,
        'events/test_filt.html',
        context
    )

def list_item_null_p(item):
    if item is not None:
        # enclose item in an li tag
        # (idea: let me pick the tag)
        pass

def all_events(request):
    event_list = Event.objects.all()
    return render(
        request,
        'events/event_list.html',
        {
            "event_list": event_list,
        }
    )

def home(request, year=False, month=False):
    # the possibilities are:
    #
    # - both month and year are real values, use them both in this case,
    #     and display the month specified by year and month
    # - year is a real value, month is False, dunno what to do in this case
    # - both month and year are false, find current year and month, use those
    #     to display that month and year
    if month == False:
        currTime = datetime.now()

        month = currTime.strftime("%B")

        if year == False:
            # both month and year are False

            year = currTime.year
        else:
            # year is a real value, month is not. what to do in this case?
            # one way, do a year calendar... or, 
            # do January of the indicated year
            
            month = "January"

    # convert month from name to number
    month_number = list(calendar.month_name).index(month.capitalize())
    month_number = int(month_number)

    cal = HTMLCalendar().formatmonth(
        year,
        month_number
    )

    return render(
        request,            # the request
        'events/home.html', # the template to render
        {                   # the context dict
            'test': "test".capitalize(),
            'year': year,
            'month': month,
            'month_number': month_number,
            'cal': cal,
        }
    )

